#version 430
// vertex attributes 
layout(location = 0) in vec3 position;
layout(location = 1) in vec3 normal;

layout(location = 0) uniform mat4 view_proj_mat;
layout(location = 4) uniform mat4 model_mat;
layout(location = 8) uniform mat3 normal_mat;

// inputs for fragment shader
out vec3 world_pos;
out vec3 screen_pos;
out vec3 vert_normal;

void main()
{
  vec4 world_pos_4 = model_mat * vec4(position, 1.0f);
  world_pos = world_pos_4.xyz;
  
  vec4 screen_pos_4 = view_proj_mat * world_pos_4;
  screen_pos = screen_pos_4.xyz;
  
  vert_normal = normal_mat * normal;
  
  
  gl_Position = screen_pos_4;
}