#version 430 core
layout(location = 0) out vec4 frag_color;
layout(location = 1) out vec4 glow_color;

in vec2 UV;
in vec4 Color;
in float TTL;

uniform sampler2D fireTexture;

vec2 spriteUV()
{
	int rows = 5;
	int cols = 5;

	int texIndex = int(TTL*float(rows*cols));
	
    int col = texIndex % cols;
    int row = texIndex / rows;
    float textXOffset = float(cols - col - 1) / float(cols);
    float textYOffset = float(rows - row - 1) / float(rows);

	return vec2(UV.x / float(cols) + textXOffset, UV.y / float(rows) + textYOffset);
}

void main()
{
	vec2 spriteUV = spriteUV();
	
	vec3 color = texture( fireTexture, spriteUV).rgb;
	frag_color = vec4(color, 0.005 * TTL);
    glow_color = frag_color;
}  